Skip to main content

How to listen to events on canvas shapes with Vue and Konva?

With vue-konva you can easily listen to user input events (click, dblclick, mouseover, tap, dbltap, touchstart, etc...) and drag&drop events (dragstart, dragmove, dragend).

For the full list of events take a look at the on() method documentation.

Instructions: Move your mouse over the triangle to see coordinates. Move the mouse out to see the mouseout event.

<template>
<v-stage ref="stage" :config="stageSize">
<v-layer ref="layer">
<v-regular-polygon
@mousemove="handleMouseMove"
@mouseout="handleMouseOut"
:config="{
x: 80,
y: 120,
sides: 3,
radius: 80,
fill: '#00D2FF',
stroke: 'black',
strokeWidth: 4
}"
/>
<v-text ref="text" :config="{
x: 10,
y: 10,
fontFamily: 'Calibri',
fontSize: 24,
text: text,
fill: 'black'
}" />
</v-layer>
</v-stage>
</template>

<script>
const width = window.innerWidth;
const height = window.innerHeight;

export default {
data() {
return {
stageSize: {
width: width,
height: height
},
text: ''
};
},
methods: {
writeMessage(message) {
this.text = message;
},
handleMouseOut(event) {
this.writeMessage('Mouseout triangle');
},
handleMouseMove(event) {
const mousePos = this.$refs.stage.getNode().getPointerPosition();
const x = mousePos.x - 190;
const y = mousePos.y - 40;
this.writeMessage('x: ' + x + ', y: ' + y);
}
}
};
</script>

Skip to main content

Angular Konva Events Tutorial

To handle events with Konva in Angular, you can use the ng2-konva library event bindings.

For full list of properties and methods, see the Konva API Reference.

Events Example

import { Component } from '@angular/core';
import { StageConfig } from 'konva/lib/Stage';
import { RegularPolygonConfig } from 'konva/lib/shapes/RegularPolygon';
import { TextConfig } from 'konva/lib/shapes/Text';

import {
  CoreShapeComponent,
  StageComponent,
} from 'ng2-konva';

@Component({
  selector: 'app-root',
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        <ko-regular-polygon
          [config]="configTriangle"
          (mousemove)="handleMouseMove($event.event)"
          (mouseout)="handleMouseOut()"
        ></ko-regular-polygon>
        <ko-text [config]="configText"></ko-text>
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class App {
  public configStage: StageConfig = {
    width: window.innerWidth,
    height: window.innerHeight,
  };
  public configTriangle: RegularPolygonConfig = {
    x: 80,
    y: 120,
    sides: 3,
    radius: 80,
    fill: '#00D2FF',
    stroke: 'black',
    strokeWidth: 4
  };
  public configText: TextConfig = {
    x: 10,
    y: 10,
    fontFamily: 'Calibri',
    fontSize: 24,
    text: 'hello',
    fill: 'black'
  };

  public handleMouseMove(event: any): void {
    const mousePos = event.target.getStage().getPointerPosition();
    const x = mousePos.x - 190;
    const y = mousePos.y - 40;
    this.configText = { ...this.configText, text: 'x: ' + x + ', y: ' + y };
  }

  public handleMouseOut(): void {
    this.configText = { ...this.configText, text: 'Mouseout triangle' };
  }
}

Skip to main content

How to listen to an event on a canvas shape with React and Konva?

With react-konva you can attach any events that Konva supports to canvas nodes.

To do that you can use the onEventName scheme, like onMouseDown for mousedown, onDragEnd for dragend, etc.

For the full list of events take a look into the on() method documentation.

In this demo you can see how we are using dragstart and dragend events to create an interactive star field:

import React from 'react';
import { Stage, Layer, Star, Text } from 'react-konva';

function generateShapes() {
  return [...Array(10)].map((_, i) => ({
    id: i.toString(),
    x: Math.random() * window.innerWidth,
    y: Math.random() * window.innerHeight,
    rotation: Math.random() * 180,
    isDragging: false,
  }));
}

const App = () => {
  const [stars, setStars] = React.useState(generateShapes());

  const handleDragStart = (e) => {
    const id = e.target.id();
    setStars(
      stars.map((star) => {
        return {
          ...star,
          isDragging: star.id === id,
        };
      })
    );
  };

  const handleDragEnd = (e) => {
    setStars(
      stars.map((star) => {
        return {
          ...star,
          isDragging: false,
        };
      })
    );
  };

  return (
    <Stage width={window.innerWidth} height={window.innerHeight}>
      <Layer>
        <Text text="Try to drag a star" />
        {stars.map((star) => (
          <Star
            key={star.id}
            id={star.id}
            x={star.x}
            y={star.y}
            numPoints={5}
            innerRadius={20}
            outerRadius={40}
            fill="#89b717"
            opacity={0.8}
            draggable
            rotation={star.rotation}
            shadowColor="black"
            shadowBlur={10}
            shadowOpacity={0.6}
            shadowOffsetX={star.isDragging ? 10 : 5}
            shadowOffsetY={star.isDragging ? 10 : 5}
            scaleX={star.isDragging ? 1.2 : 1}
            scaleY={star.isDragging ? 1.2 : 1}
            onDragStart={handleDragStart}
            onDragEnd={handleDragEnd}
          />
        ))}
      </Layer>
    </Stage>
  );
};

export default App;